package com.hzya.frame.plugin.cbs8.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.cbs8.dto.req.TransactionDetailReqDTO;
import com.hzya.frame.cbs8.dto.res.TransactionDetailDTO;

import java.util.List;

/**
 * @Description
 * @Author xiangerlin
 * @Date 2024/6/17 08:46
 **/
public interface ICbsPluginService {

    /**
     * 支付申请
     * @param requestJson
     */
     void applyPay(JSONObject requestJson)throws Exception;

    /**
     * 查询支付申请的交易结果
     * @param requestJson
     * @throws Exception
     */
     void queryResult(JSONObject requestJson)throws Exception;

    /**
     * 电子回单查询 并上传OA
     * @param requestJson
     * @throws Exception
     */
    void elecBillUpload(JSONObject requestJson)throws Exception;

    /**
     * 查询交易明细
     * transactionDetailReqDTO.currentPage 、 transactionDetailReqDTO.pageSize 必填
     * @param transactionDetailReqDTO
     */
    List<TransactionDetailDTO> queryTransactionDetail(TransactionDetailReqDTO transactionDetailReqDTO);
}
