package com.hzya.frame.mdm.service.impl;

import cn.dev33.satoken.stp.StpUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.mdm.entity.DbFiledsDto;
import com.hzya.frame.mdm.entity.MdmDataDto;
import com.hzya.frame.mdm.entity.MdmDataFiledDto;
import com.hzya.frame.mdm.entity.MdmDbFiledVo;
import com.hzya.frame.mdm.entity.MdmDbVo;
import com.hzya.frame.mdm.entity.MdmDetailViewVo;
import com.hzya.frame.mdm.entity.MdmDistributeDto;
import com.hzya.frame.mdm.entity.MdmDto;
import com.hzya.frame.mdm.entity.MdmModuleViewDto;
import com.hzya.frame.mdm.entity.MdmModuleViewVo;
import com.hzya.frame.mdm.entity.MdmQuery;
import com.hzya.frame.mdm.entity.MdmSourceDto;
import com.hzya.frame.mdm.entity.MdmViewFiledVo;
import com.hzya.frame.mdm.entity.MdmViewVo;
import com.hzya.frame.mdm.mdmModule.dao.IMdmModuleDao;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModuleDb.dao.IMdmModuleDbDao;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.dao.IMdmModuleDbFiledsDao;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.IMdmModuleDbFiledsRuleDao;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity;
import com.hzya.frame.mdm.mdmModuleDistribute.dao.IMdmModuleDistributeDao;
import com.hzya.frame.mdm.mdmModuleDistribute.entity.MdmModuleDistributeEntity;
import com.hzya.frame.mdm.mdmModuleDistributeDetail.dao.IMdmModuleDistributeDetailDao;
import com.hzya.frame.mdm.mdmModuleOptionLog.dao.IMdmModuleOptionLogDao;
import com.hzya.frame.mdm.mdmModuleOptionLog.entity.MdmModuleOptionLogEntity;
import com.hzya.frame.mdm.mdmModuleSendLog.dao.IMdmModuleSendLogDao;
import com.hzya.frame.mdm.mdmModuleSendLog.entity.MdmModuleSendLogEntity;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.mdm.mdmModuleView.dao.IMdmModuleViewDao;
import com.hzya.frame.mdm.mdmModuleView.entity.MdmModuleViewEntity;
import com.hzya.frame.mdm.mdmModuleViewButton.dao.IMdmModuleViewButtonDao;
import com.hzya.frame.mdm.mdmModuleViewButton.entity.MdmModuleViewButtonEntity;
import com.hzya.frame.mdm.mdmModuleViewDetail.dao.IMdmModuleViewDetailDao;
import com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity;
import com.hzya.frame.mdm.mdmTableCodeRule.dao.IMdmTableCodeRuleDao;
import com.hzya.frame.mdm.mdmTableCodeRule.entity.MdmTableCodeRuleEntity;
import com.hzya.frame.mdm.service.IMdmService;

import com.hzya.frame.mdm.service.IMdmServiceCache;
import com.hzya.frame.sys.entity.FormmainDeleteDto;
import com.hzya.frame.sysnew.buttonConfig.dao.ISysButtonConfigDao;
import com.hzya.frame.sysnew.buttonConfig.entity.SysButtonConfigEntity;
import com.hzya.frame.sysnew.menuConfig.dao.ISysMenuConfigDao;
import com.hzya.frame.sysnew.menuConfig.entity.SysMenuConfigEntity;
import com.hzya.frame.sysnew.popedomOperate.dao.ISysPopedomOperateDao;
import com.hzya.frame.sysnew.popedomOperate.entity.SysPopedomOperateEntity;
import com.hzya.frame.sysnew.user.entity.SysUserEntity;
import com.hzya.frame.sysnew.userCompany.entity.SysUserCompanyEntity;
import com.hzya.frame.sysnew.userRoles.entity.SysUserRolesEntity;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.checkerframework.checker.units.qual.A;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * 主数据服务实现类
 */
@Service(value = "mdmService")
public class MdmServiceImpl implements IMdmService {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Resource
    private IMdmModuleDao mdmModuleDao;
    @Resource
    private IMdmModuleSendLogDao mdmModuleSendLogDao;
    @Resource
    private IMdmModuleOptionLogDao mdmModuleOptionLogDao;
    @Resource
    private IMdmServiceCache mdmServiceCache;
    @Resource
    private ISysMenuConfigDao sysMenuConfigDao;
    @Resource
    private ISysButtonConfigDao sysButtonConfigDao;
    @Resource
    private ISysPopedomOperateDao sysPopedomOperateDao;
    @Resource
    private IMdmModuleDbDao mdmModuleDbDao;
    @Resource
    private IMdmModuleDbFiledsDao mdmModuleDbFiledsDao;
    @Resource
    private IMdmModuleDbFiledsRuleDao mdmModuleDbFiledsRuleDao;
    @Resource
    private IMdmTableCodeRuleDao mdmTableCodeRuleDao;
    @Resource
    private IMdmModuleDistributeDao mdmModuleDistributeDao;
    @Resource
    private IMdmModuleDistributeDetailDao mdmModuleDistributeDetailDao;
    @Resource
    private IMdmModuleViewDao mdmModuleViewDao;
    @Resource
    private IMdmModuleViewButtonDao mdmModuleViewButtonDao;
    @Resource
    private IMdmModuleViewDetailDao mdmModuleViewDetailDao;


    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表显示 树、查询条件、列表字段、按钮
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShow(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if(mdmModuleEntity == null || mdmModuleEntity.getId() == null){
            return BaseResult.getFailureMessageEntity("系统错误");
        }

        //设置模版
        MdmViewVo mdmViewVo = new MdmViewVo();
        mdmViewVo.setMdmModuleEntity(mdmModuleEntity);
        //查询展示类型
        MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
        mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewEntity.setSts("Y");
        List<MdmModuleViewEntity> moduleViewEntityList = mdmModuleViewDao.queryBase(mdmModuleViewEntity);
        if (moduleViewEntityList == null || moduleViewEntityList.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleViewEntity = moduleViewEntityList.get(0);
        mdmViewVo.setMdmModuleViewEntity(mdmModuleViewEntity);

        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表下面的字段
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
        if (mdmModuleDbFiledsEntityList == null || mdmModuleDbFiledsEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询字段下的规则
        MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = new MdmModuleDbFiledsRuleEntity();
        mdmModuleDbFiledsRuleEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsRuleEntity.setSts("Y");
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList = mdmModuleDbFiledsRuleDao.queryBase(mdmModuleDbFiledsRuleEntity);
        if (mdmModuleDbFiledsRuleEntityList == null || mdmModuleDbFiledsRuleEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }

        //查询设置的查询字段
        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleViewDetailEntity.setSts("Y");
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities = mdmModuleViewDetailDao.queryBase(mdmModuleViewDetailEntity);
        if (mdmModuleViewDetailEntities == null || mdmModuleViewDetailEntities.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        List<MdmViewFiledVo> queryList = getFiledByType("1",mdmModuleViewDetailEntities,mdmModuleDbEntityList,mdmModuleDbFiledsEntityList,mdmModuleDbFiledsRuleEntityList);
        mdmViewVo.setQueryList(queryList);
        List<MdmViewFiledVo> listList = getFiledByType("2",mdmModuleViewDetailEntities,mdmModuleDbEntityList,mdmModuleDbFiledsEntityList,mdmModuleDbFiledsRuleEntityList);
        mdmViewVo.setListList(listList);
        return BaseResult.getSuccessMessageEntity("获取字段成功", mdmViewVo);
    }

    /**
     * @Author lvleigang
     * @Description  根据类型获取字段
     * @Date 9:18 上午 2024/6/6
     * @param viewType 类型
     * @param mdmModuleViewDetailEntities 显示设置的字段
     * @param mdmModuleDbEntityList 表
     * @param mdmModuleDbFiledsEntityList 表字段
     * @param mdmModuleDbFiledsRuleEntityList 字段规则
     * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewFiledVo>
     **/
    private List<MdmViewFiledVo> getFiledByType(String viewType, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList) {
        List<MdmViewFiledVo> mdmViewFiledVos = new ArrayList<>();
        if(mdmModuleViewDetailEntities != null && mdmModuleViewDetailEntities.size() > 0){
            for (int i = 0; i < mdmModuleViewDetailEntities.size(); i++) {
                if(viewType.equals(mdmModuleViewDetailEntities.get(i).getViewType())){
                    //类型一致
                    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
                    mdmViewFiledVo.setId(mdmModuleViewDetailEntities.get(i).getViewFiled());
                    for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                        if(mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleViewDetailEntities.get(i).getViewFiled())){
                            for (int i2 = 0; i2 < mdmModuleDbEntityList.size(); i2++) {
                                if(mdmModuleDbEntityList.get(i2).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())){
                                    mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i2).getDbName());
                                    mdmViewFiledVo.setDbType(mdmModuleDbEntityList.get(i2).getDbType());
                                    mdmViewFiledVo.setMdmId(mdmModuleDbEntityList.get(i2).getMdmId());
                                    mdmViewFiledVo.setDbId(mdmModuleDbEntityList.get(i2).getId());

                                    break;
                                }
                            }
                            mdmViewFiledVo.setChName(mdmModuleDbFiledsEntityList.get(i1).getChName());
                            mdmViewFiledVo.setEnName(mdmModuleDbFiledsEntityList.get(i1).getEnName());
                            mdmViewFiledVo.setFiledType(mdmModuleDbFiledsEntityList.get(i1).getFiledType());
                            //字段规则
                            if(mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0){
                                List<MdmModuleDbFiledsRuleEntity> ruleList = new ArrayList<>();
                                for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                    if(mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())){
                                        ruleList.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                    }
                                }
                                mdmViewFiledVo.setRuleList(ruleList);
                            }
                            break;
                        }
                    }
                }
            }
        }
        if(mdmViewFiledVos != null && mdmViewFiledVos.size() > 0){
            for (int i = 0; i < mdmViewFiledVos.size(); i++) {
                mdmViewFiledVos.get(i).setSorts(i);
            }
        }
        return mdmViewFiledVos;
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据查询所有字段
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowAll(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询设置各种类型字段
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        //查询模版数据源
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        List<MdmDbFiledVo> listFiled = new ArrayList<>();
        if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
            mdmModuleDbFiledsEntity.setSts("Y");
            List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
            //
            if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
                for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                    if("1".equals(mdmModuleDbEntityList.get(i).getDbType()) || "2".equals(mdmModuleDbEntityList.get(i).getDbType())){
                        if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                            for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                                if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                    if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                                        //1、主表
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【主表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    } else {
                                        //2、明细
                                        listFiled.add(new MdmDbFiledVo(mdmModuleDbFiledsEntityList.get(i1).getId(), "【子表:" + mdmModuleDbEntityList.get(i).getDbName() + "】" + mdmModuleDbFiledsEntityList.get(i1).getChName()));
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return BaseResult.getSuccessMessageEntity("查询视图成功", listFiled);
    }
    //
    ///**
    // * @param mdmModuleRoleButtonEntities
    // * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewButtonVo>
    // * @Author lvleigang
    // * @Description 设置返回按钮
    // * @Date 4:48 下午 2023/10/26
    // **/
    //private List<MdmViewButtonVo> setButton(List<MdmModuleRoleButtonEntity> mdmModuleRoleButtonEntities) {
    //    List<MdmViewButtonVo> mdmViewButtonVoList = new ArrayList<>();
    //    if (mdmModuleRoleButtonEntities != null && mdmModuleRoleButtonEntities.size() > 0) {
    //        for (int i = 0; i < mdmModuleRoleButtonEntities.size(); i++) {
    //            mdmViewButtonVoList.add(new MdmViewButtonVo(mdmModuleRoleButtonEntities.get(i).getButtonType(), mdmModuleRoleButtonEntities.get(i).getButtonName()));
    //        }
    //    }
    //    return mdmViewButtonVoList;
    //}
    //
    ///**
    // * @param allRecords
    // * @param checkedMeters
    // * @return java.util.List<com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity>
    // * @Author lvleigang
    // * @Description 取出重复字段数据
    // * @Date 4:34 下午 2023/10/26
    // **/
    //private List<MdmModuleViewDetailEntity> getDolist(List<MdmModuleViewDetailEntity> allRecords, List<MdmModuleUserViewEntity> checkedMeters) {
    //    List<MdmModuleViewDetailEntity> meterPlan = allRecords.stream()
    //            .filter(item -> checkedMeters.stream()
    //                    .map(e -> {
    //                        if (!Objects.equals(item.getViewFiled(), e.getViewDetailId())) {
    //                            return null;
    //                        } else {
    //                            return item.getViewFiled();
    //                        }
    //                    })
    //                    .collect(Collectors.toList())
    //                    .contains(item.getViewFiled()))
    //            .collect(Collectors.toList());
    //    return meterPlan;
    //}
    //
    ///**
    // * @param mdmModuleDbEntityList           数据源
    // * @param mdmModuleDbFiledsEntityList     数据源下的字段表
    // * @param mdmModuleDbFiledsRuleEntityList 数据源字段的规则表
    // * @param queryList                       需要的字段
    // * @return java.util.List<com.hzya.frame.mdm.entity.MdmViewFiledVo>
    // * @Author lvleigang
    // * @Description 根据字段设置返回前台字段
    // * @Date 4:11 下午 2023/10/26
    // **/
    //private List<MdmViewFiledVo> setQueryList(List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList, List<MdmModuleViewDetailEntity> queryList, boolean flag) {
    //    List<MdmViewFiledVo> mdmViewFiledVos = new ArrayList<>();
    //
    //    if (queryList != null && queryList.size() > 0) {
    //        for (int i = 0; i < queryList.size(); i++) {
    //            MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //            mdmViewFiledVo.setId(queryList.get(i).getViewFiled());//字段id
    //            mdmViewFiledVo.setSorts(i + 2);//排序
    //            for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
    //                if (queryList.get(i).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
    //                    mdmViewFiledVo.setFiledType(mdmModuleDbFiledsEntityList.get(i1).getFiledType());//英文名
    //                    mdmViewFiledVo.setEnName(mdmModuleDbFiledsEntityList.get(i1).getEnName());//英文名
    //                    mdmViewFiledVo.setChName(mdmModuleDbFiledsEntityList.get(i1).getChName());//中文名
    //                    for (int i2 = 0; i2 < mdmModuleDbEntityList.size(); i2++) {
    //                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i2).getId())) {
    //                            mdmViewFiledVo.setDbType(mdmModuleDbEntityList.get(i2).getDbType());//类型 1、主表 2、明细
    //                            mdmViewFiledVo.setMdmId(mdmModuleDbEntityList.get(i2).getMdmId());//主数据模版ID
    //                            mdmViewFiledVo.setDbId(mdmModuleDbEntityList.get(i2).getId());//模版数据库id
    //                            mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i2).getDbName());//表名
    //
    //                            break;
    //                        }
    //                    }
    //                    break;
    //                }
    //            }
    //            //设置字段规则
    //            List<MdmModuleDbFiledsRuleEntity> ruleList = new ArrayList<>();
    //            if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
    //                for (int i1 = 0; i1 < mdmModuleDbFiledsRuleEntityList.size(); i1++) {
    //                    if (queryList.get(i).getViewFiled().equals(mdmModuleDbFiledsRuleEntityList.get(i1).getFiledId())) {
    //                        ruleList.add(mdmModuleDbFiledsRuleEntityList.get(i1));
    //                    }
    //                }
    //            }
    //            mdmViewFiledVo.setRuleList(ruleList);
    //            mdmViewFiledVos.add(mdmViewFiledVo);
    //        }
    //    }
    //    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //    mdmViewFiledVo.setSorts(1);//排序
    //    mdmViewFiledVo.setFiledType("3");
    //    mdmViewFiledVo.setEnName("document_rule");//英文名
    //    mdmViewFiledVo.setChName("单据编码");//中文名
    //    mdmViewFiledVo.setDbType("1");//类型 1、主表 2、明细
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
    //            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
    //                mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i).getDbName());//表名
    //            }
    //        }
    //    }
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("单据编码");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("12");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    MdmModuleDbFiledsRuleEntity withs = new MdmModuleDbFiledsRuleEntity();
    //    withs.setFormName("optionRuleForm");
    //    withs.setRuleCode("width");
    //    withs.setRuleName("宽度");
    //    withs.setRuleType("2");
    //    withs.setRuleValue("200");
    //    msgRule.add(withs);
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    mdmViewFiledVo.setRuleList(msgRule);
    //    mdmViewFiledVos.add(0, mdmViewFiledVo);
    //
    //    //添加分发数量
    //    if (flag) {
    //        addFfsl(mdmModuleDbEntityList, mdmViewFiledVos);
    //    }
    //    return mdmViewFiledVos;
    //}
    //
    //private void addFfsl(List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmViewFiledVo> mdmViewFiledVos) {
    //
    //    MdmViewFiledVo mdmViewFiledVo = new MdmViewFiledVo();
    //    mdmViewFiledVo.setSorts(1);//排序
    //    mdmViewFiledVo.setFiledType("1");
    //    mdmViewFiledVo.setEnName("qwqwasdasdzxasda");//英文名
    //    mdmViewFiledVo.setChName("分发数量");//中文名
    //    mdmViewFiledVo.setDbType("1");//类型 1、主表 2、明细
    //    if (mdmModuleDbEntityList != null && mdmModuleDbEntityList.size() > 0) {
    //        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
    //            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
    //                mdmViewFiledVo.setDbName(mdmModuleDbEntityList.get(i).getDbName());//表名
    //            }
    //        }
    //    }
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("分发数量");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    mdmViewFiledVo.setRuleList(msgRule);
    //    mdmViewFiledVos.add(mdmViewFiledVo);
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据列表显示 业务数据
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowData(JSONObject object) {
        MdmQuery entity = getData("jsonStr", object, MdmQuery.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        //判断分页
        if (entity == null || entity.getPageNum() == null || entity.getPageSize() == null) {
            return BaseResult.getFailureMessageEntity("分页查询参数不存在");
        }
        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
        List<HashMap<String, Object>> businessResult = mdmModuleDao.queryMdmShowData(entity);
        PageInfo pageInfo = new PageInfo(businessResult);
        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    }
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 主数据列表显示 业务数据
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity queryMdmShowDistribute(JSONObject object) {
    //    MdmDto entity = getData("jsonStr", object, MdmDto.class);
    //    if (entity == null) {
    //        return BaseResult.getFailureMessageEntity("参数不允许为空");
    //    }
    //    if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    if (entity.getId() == null || "".equals(entity.getId())) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    //查询模版
    //    MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //    mdmModuleEntity.setMdmCode(entity.getMdmCode());
    //    mdmModuleEntity.setSts("Y");
    //    List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //    if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //
    //    //查询数据源主表
    //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //    mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //    mdmModuleDbEntity.setDbType("1");
    //    mdmModuleDbEntity.setSts("Y");
    //    List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //    if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    mdmModuleDbEntity = mdmModuleDbEntityList.get(0);
    //    Map<String, Object> queryData = new HashMap<>();
    //    queryData.put("tableName", mdmModuleDbEntity.getDbName() + "_distribute");//表名
    //    queryData.put("id", entity.getId());//字段
    //    List<MdmDistributeVo> datas = mdmModuleDbDao.getServiceByDistributeIdNoCase(queryData);
    //    List<MdmDistributeVo> returnData = new ArrayList<>();
    //
    //    //查询分发表
    //    MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //    mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //    mdmModuleDistributeEntity.setSts("Y");
    //    List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //    if (datas != null && datas.size() > 0) {
    //        if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() > 0) {
    //            for (int i = 0; i < mdmModuleDistributeEntities.size(); i++) {
    //                boolean flag = false;
    //                for (int i1 = 0; i1 < datas.size(); i1++) {
    //                    if (datas.get(i1).getAppId().equals(mdmModuleDistributeEntities.get(i).getAppId())) {
    //                        flag = true;
    //                        break;
    //                    }
    //                }
    //                if (!flag) {
    //                    MdmDistributeVo mdmDistributeVo = new MdmDistributeVo();
    //                    mdmDistributeVo.setAppId(mdmModuleDistributeEntities.get(i).getAppId());
    //                    mdmDistributeVo.setStatus("4");
    //                    mdmDistributeVo.setMsg("未发送");
    //                    returnData.add(mdmDistributeVo);
    //                }
    //            }
    //        }
    //        returnData.addAll(datas);
    //    } else {
    //        if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() > 0) {
    //            for (int i = 0; i < mdmModuleDistributeEntities.size(); i++) {
    //                MdmDistributeVo mdmDistributeVo = new MdmDistributeVo();
    //                mdmDistributeVo.setAppId(mdmModuleDistributeEntities.get(i).getAppId());
    //                mdmDistributeVo.setStatus("4");
    //                mdmDistributeVo.setMsg("未发送");
    //                returnData.add(mdmDistributeVo);
    //            }
    //        }
    //    }
    //    return BaseResult.getSuccessMessageEntity("查询数据成功", returnData);
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 查询数据（list 或者 分页）
     * @Date 1:33 下午 2023/7/12
     **/
    @Override
    public JsonResultEntity queryTemplateData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        //校验是否有servecr传参
        if (!checkStr(entity.getTableName())) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkStr(entity.getValue())) {
            return BaseResult.getFailureMessageEntity("请先传递存储字段");
        }
        if (!checkStr(entity.getLabel())) {
            return BaseResult.getFailureMessageEntity("请先传递显示字段");
        }
        if (entity.getPageNum() != null && entity.getPageSize() != null) {
            PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
            List<HashMap<String, Object>> mapList = mdmModuleDao.querySelectData(entity);
            PageInfo pageInfo = new PageInfo(mapList);
            return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
        } else {
            List<HashMap<String, Object>> mapList = mdmModuleDao.querySelectData(entity);
            return BaseResult.getSuccessMessageEntity("查询数据成功", mapList);
        }
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 业务数据树形结构，数据查询
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowTreeData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        //if (entity.getTableName() == null || "".equals(entity.getTableName())) {
        //    return BaseResult.getFailureMessageEntity("系统错误");
        //}
        if (entity.getLabel() == null || "".equals(entity.getLabel())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getUpId() == null || "".equals(entity.getUpId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");

        }
        //查询模版
        MdmModuleEntity  mdmModuleEntities = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntities == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            if("1".equals(mdmModuleDbEntityList.get(i).getDbType())){
                mdmModuleDbEntity = mdmModuleDbEntityList.get(i);
                break;
            }
        }
        entity.setTableName(mdmModuleDbEntity.getDbName());



        if (checkStr(entity.getId())) {
            if (!checkStr(entity.getValue())) {
                return BaseResult.getFailureMessageEntity("请先传递存储字段");
            }
            if (entity.getId().contains(",")) {
                String[] strArray = entity.getId().split(",");  // 使用逗号和空格作为分隔符
                entity.setIds(strArray);
                List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateDataMore(entity);
                if (mapList == null || mapList.size() == 0) {
                    List<HashMap<String, Object>> returnList = new ArrayList<>();
                    return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
                }
                List<HashMap<String, Object>> returnList = gettochilder(strArray, 0, mapList);
                return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
            } else {
                HashMap<String, Object> mapList = mdmModuleDao.queryTemplateDataOne(entity);
                if (mapList == null || mapList.size() == 0) {
                    List<HashMap<String, Object>> returnList = new ArrayList<>();
                    return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
                }
                List<HashMap<String, Object>> returnList = new ArrayList<>();
                returnList.add(mapList);
                return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
            }
        } else {
            List<HashMap<String, Object>> mapList = mdmModuleDao.queryDataAll(entity);
            List<HashMap<String, Object>> returnList = new ArrayList<>();

            if (mapList != null && mapList.size() > 0) {
                for (int i = 0; i < mapList.size(); i++) {
                    //默认为根
                    if (mapList.get(i).get(entity.getUpId()) == null || "".equals(mapList.get(i).get(entity.getUpId()))) {
                        List<HashMap<String, Object>> children = getchilder(mapList.get(i).get("qsdfg").toString(), mapList, entity);
                        HashMap<String, Object> re = new HashMap<>();
                        re.put("id", mapList.get(i).get("qsdfg"));
                        re.put("label", mapList.get(i).get(entity.getLabel()));
                        re.put("upID", mapList.get(i).get(entity.getUpId()));
                        if (children != null && children.size() > 0) {
                            re.put("children", children);
                        }
                        returnList.add(re);
                    }
                }
            }
            return BaseResult.getSuccessMessageEntity("查询数据成功", returnList);
        }
    }
    //
    private List<HashMap<String, Object>> gettochilder(String[] strArray, int i, List<HashMap<String, Object>> mapList) {
        List<HashMap<String, Object>> maps = new ArrayList<>();
        for (int i1 = 0; i1 < mapList.size(); i1++) {
            if (strArray[i].equals(mapList.get(i1).get("id").toString())) {
                if (strArray.length >= (i + 2)) {
                    mapList.get(i1).put("children", gettochilder(strArray, i + 1, mapList));
                }
                maps.add(mapList.get(i1));
                break;
            }
        }
        return maps;
    }
    //
    //private HashMap<String, Object> getFathers(List<HashMap<String, Object>> mapListAll, HashMap<String, Object> mapList, MdmDto entity) {
    //    if (mapList.get("upID") == null) {
    //        return mapList;
    //    }
    //    HashMap<String, Object> retList = new HashMap<>();
    //    if (mapListAll != null && mapListAll.size() > 0) {
    //        for (int i = 0; i < mapListAll.size(); i++) {
    //            //等于上级id的时候
    //            if (mapListAll.get(i).get("qsdfg").equals(mapList.get("upID"))) {
    //                retList.put("id", mapListAll.get(i).get("qsdfg"));
    //                retList.put("label", mapListAll.get(i).get(entity.getLabel()));
    //                retList.put("upID", mapListAll.get(i).get(entity.getUpId()));
    //                List<HashMap<String, Object>> returnList = new ArrayList<>();
    //                returnList.add(mapList);
    //                retList.put("children", returnList);
    //                break;
    //            }
    //        }
    //    }
    //    HashMap<String, Object> a = getFathers(mapListAll, retList, entity);
    //    return a;
    //}
    //
    private List<HashMap<String, Object>> getchilder(String stringObjectHashMap, List<HashMap<String, Object>> mapList, MdmDto entity) {
        List<HashMap<String, Object>> returnList = new ArrayList<>();
        if (mapList != null && mapList.size() > 0) {
            for (int i = 0; i < mapList.size(); i++) {
                //等于上级id的时候
                if (stringObjectHashMap.equals(mapList.get(i).get(entity.getUpId()))) {
                    List<HashMap<String, Object>> children = getchilder(mapList.get(i).get(entity.getUpId()) + "," + mapList.get(i).get("qsdfg"), mapList, entity);
                    HashMap<String, Object> re = new HashMap<>();
                    re.put("id", mapList.get(i).get("qsdfg"));
                    re.put("label", mapList.get(i).get(entity.getLabel()));
                    re.put("upID", mapList.get(i).get(entity.getUpId()));
                    if (children != null && children.size() > 0) {
                        re.put("children", children);
                    }
                    returnList.add(re);
                }
            }
        }
        return returnList;
    }
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情 区分类型 新增、修改、查看
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowDetails(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getShowType() == null || "".equals(entity.getShowType())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版
        //List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        MdmModuleEntity mdmModuleEntities = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntities == null) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmDetailViewVo mdmViewVo = new MdmDetailViewVo();
        mdmViewVo.setMdmModuleEntity(mdmModuleEntities);

        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源表下面的字段
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
        if (mdmModuleDbFiledsEntityList == null || mdmModuleDbFiledsEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询字段下的规则
        MdmModuleDbFiledsRuleEntity mdmModuleDbFiledsRuleEntity = new MdmModuleDbFiledsRuleEntity();
        mdmModuleDbFiledsRuleEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleDbFiledsRuleEntity.setSts("Y");
        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList = mdmModuleDbFiledsRuleDao.queryBase(mdmModuleDbFiledsRuleEntity);
        if (mdmModuleDbFiledsRuleEntityList == null || mdmModuleDbFiledsRuleEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleViewDetailEntity mdmModuleViewDetailEntity = new MdmModuleViewDetailEntity();
        mdmModuleViewDetailEntity.setMdmId(mdmModuleEntities.getId());
        mdmModuleViewDetailEntity.setSts("Y");
        mdmModuleViewDetailEntity.setViewType(entity.getShowType());//设置显示字段类型
        List<MdmModuleViewDetailEntity> queryAll = mdmModuleViewDetailDao.queryBase(mdmModuleViewDetailEntity);
        List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList = new ArrayList<>();
        if(queryAll != null && queryAll.size() > 0){
            for (int i = 0; i < queryAll.size(); i++) {
                if(entity.getShowType().equals(queryAll.get(i).getViewType())){
                    mdmModuleViewDetailEntityList.add(queryAll.get(i));
                }
            }
        }
        //组装数据
        assembleMdmShowDetails(mdmViewVo, mdmModuleDbEntityList, mdmModuleDbFiledsEntityList, mdmModuleDbFiledsRuleEntityList, mdmModuleViewDetailEntityList, entity.getShowType());
        return BaseResult.getSuccessMessageEntity("获取字段成功", mdmViewVo);
    }

    /**
     * @param mdmViewVo                       返回对象
     * @param mdmModuleDbEntityList           数据源表
     * @param mdmModuleDbFiledsEntityList     数据源字段
     * @param mdmModuleDbFiledsRuleEntityList 数据源字段规则
     * @param mdmModuleViewDetailEntityList   数据源显示字段
     * @return void
     * @Author lvleigang
     * @Description 组装显示字段
     * @Date 9:10 上午 2023/11/6
     **/
    private void assembleMdmShowDetails(MdmDetailViewVo mdmViewVo, List<MdmModuleDbEntity> mdmModuleDbEntityList, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntityList, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntityList, String showType) {
        //主数据主表
        MdmModuleDbEntity mainMdmModuleDb = new MdmModuleDbEntity();
        List<MdmModuleDbFiledsEntity> mainMdmModuleDbFileds = new ArrayList<>();
        //主数据子表
        List<MdmModuleDbEntity> sublistMdmModuleDb = new ArrayList<>();

        if (mdmModuleViewDetailEntityList != null && mdmModuleViewDetailEntityList.size() > 0) {
            //先循环数据源表，设置出数据字段
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //1、主表 2、明细
                    mainMdmModuleDb = mdmModuleDbEntityList.get(i);
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                for (int b = 0; b < mdmModuleViewDetailEntityList.size(); b++) {
                                    if (mdmModuleViewDetailEntityList.get(b).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
                                        mainMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                        //循环字段属性
                                        if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                            for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                                if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                        && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                                    mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                                }
                                            }
                                        }
                                        mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                                    }
                                }
                            }
                        }
                    }
                } else if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //2、明细
                    sublistMdmModuleDb.add(mdmModuleDbEntityList.get(i));
                    //循环字段表
                    if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
                        List<MdmModuleDbFiledsEntity> sublistMdmModuleDbFileds = new ArrayList<>();
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbEntityList.get(i).getId().equals(mdmModuleDbFiledsEntityList.get(i1).getDbId())) {
                                for (int b = 0; b < mdmModuleViewDetailEntityList.size(); b++) {
                                    if (mdmModuleViewDetailEntityList.get(b).getViewFiled().equals(mdmModuleDbFiledsEntityList.get(i1).getId())) {
                                        sublistMdmModuleDbFileds.add(mdmModuleDbFiledsEntityList.get(i1));
                                        List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRules = new ArrayList<>();
                                        //循环字段属性
                                        if (mdmModuleDbFiledsRuleEntityList != null && mdmModuleDbFiledsRuleEntityList.size() > 0) {
                                            for (int i2 = 0; i2 < mdmModuleDbFiledsRuleEntityList.size(); i2++) {
                                                if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getDbId())
                                                        && mdmModuleDbFiledsEntityList.get(i1).getId().equals(mdmModuleDbFiledsRuleEntityList.get(i2).getFiledId())) {
                                                    mdmModuleDbFiledsRules.add(mdmModuleDbFiledsRuleEntityList.get(i2));
                                                }
                                            }
                                        }
                                        mdmModuleDbFiledsEntityList.get(i1).setMdmModuleDbFiledsRules(mdmModuleDbFiledsRules);
                                    }
                                }

                            }
                        }
                        mdmModuleDbEntityList.get(i).setSublistMdmModuleDbFileds(sublistMdmModuleDbFileds);
                    }
                }
            }
            mainMdmModuleDb.setSublistMdmModuleDbFileds(mainMdmModuleDbFileds);
            mdmViewVo.setMainMdmModuleDb(mainMdmModuleDb);
            //主数据子表
            List<MdmModuleDbEntity> mdmModuleDb = new ArrayList<>();
            if (sublistMdmModuleDb != null && sublistMdmModuleDb.size() > 0) {
                for (int i = 0; i < sublistMdmModuleDb.size(); i++) {
                    if (sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds() != null && sublistMdmModuleDb.get(i).getSublistMdmModuleDbFileds().size() > 0) {
                        mdmModuleDb.add(sublistMdmModuleDb.get(i));
                    }
                }
            }
            //if ("5".equals(showType)) {
            //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
            //    mdmModuleDbEntity.setDbName(mainMdmModuleDb.getDbName() + "_distribute");
            //    mdmModuleDbEntity.setRemark(mainMdmModuleDb.getRemark() + "分发表");
            //    mdmModuleDbEntity.setDbType("2");
            //    List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList1 = getDistributeRole();
            //    mdmModuleDbEntity.setSublistMdmModuleDbFileds(mdmModuleDbFiledsEntityList1);
            //    mdmModuleDb.add(mdmModuleDbEntity);
            //}
            mdmViewVo.setSublistMdmModuleDb(mdmModuleDb);

        } else {
            mdmViewVo.setMainMdmModuleDb(mainMdmModuleDb);
            mdmViewVo.setSublistMdmModuleDb(sublistMdmModuleDb);
        }
    }
    //
    //private List<MdmModuleDbFiledsEntity> getDistributeRole() {
    //    List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = new ArrayList<>();
    //    //app
    //    MdmModuleDbFiledsEntity appFiled = new MdmModuleDbFiledsEntity();
    //    appFiled.setChName("应用");
    //    appFiled.setEnName("app_id");
    //    appFiled.setFiledLength("50");
    //    appFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> appRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity appRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    appRuleTitie.setFormName("optionRuleForm");
    //    appRuleTitie.setRuleCode("title");
    //    appRuleTitie.setRuleName("显示名");
    //    appRuleTitie.setRuleType("2");
    //    appRuleTitie.setRuleValue("应用");
    //    MdmModuleDbFiledsRuleEntity appRulerow = new MdmModuleDbFiledsRuleEntity();
    //    appRulerow.setFormName("optionRuleForm");
    //    appRulerow.setRuleCode("row");
    //    appRulerow.setRuleName("宽度");
    //    appRulerow.setRuleType("2");
    //    appRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity appRuletype = new MdmModuleDbFiledsRuleEntity();
    //    appRuletype.setFormName("optionRuleForm");
    //    appRuletype.setRuleCode("type");
    //    appRuletype.setRuleName("数据类型");
    //    appRuletype.setRuleType("2");
    //    appRuletype.setRuleValue("select");
    //    MdmModuleDbFiledsRuleEntity appRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    appRulerequired.setFormName("optionRuleForm");
    //    appRulerequired.setRuleCode("required");
    //    appRulerequired.setRuleName("必填");
    //    appRulerequired.setRuleType("2");
    //    MdmModuleDbFiledsRuleEntity appRuleservice = new MdmModuleDbFiledsRuleEntity();
    //    appRuleservice.setFormName("typeOptionRuleForm");
    //    appRuleservice.setRuleCode("service");
    //    appRuleservice.setRuleName("服务名称");
    //    appRuleservice.setRuleType("2");
    //    appRuleservice.setRuleValue("sys_application");
    //    MdmModuleDbFiledsRuleEntity appRulelabel = new MdmModuleDbFiledsRuleEntity();
    //    appRulelabel.setFormName("typeOptionRuleForm");
    //    appRulelabel.setRuleCode("label");
    //    appRulelabel.setRuleName("label");
    //    appRulelabel.setRuleType("2");
    //    appRulelabel.setRuleValue("name");
    //    MdmModuleDbFiledsRuleEntity appRulevalue = new MdmModuleDbFiledsRuleEntity();
    //    appRulevalue.setFormName("typeOptionRuleForm");
    //    appRulevalue.setRuleCode("value");
    //    appRulevalue.setRuleName("value");
    //    appRulevalue.setRuleType("2");
    //    appRulevalue.setRuleValue("id");
    //    appRule.add(appRulevalue);
    //    appRule.add(appRulelabel);
    //    appRule.add(appRuleservice);
    //    appRule.add(appRulerequired);
    //    appRule.add(appRuletype);
    //    appRule.add(appRulerow);
    //    appRule.add(appRuleTitie);
    //    appFiled.setMdmModuleDbFiledsRules(appRule);
    //    mdmModuleDbFiledsEntityList.add(appFiled);
    //
    //
    //    //status
    //    MdmModuleDbFiledsEntity statusFiled = new MdmModuleDbFiledsEntity();
    //    statusFiled.setChName("状态");
    //    statusFiled.setEnName("status");
    //    statusFiled.setFiledLength("50");
    //    statusFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> statusRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity statusRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    statusRuleTitie.setFormName("optionRuleForm");
    //    statusRuleTitie.setRuleCode("title");
    //    statusRuleTitie.setRuleName("显示名");
    //    statusRuleTitie.setRuleType("2");
    //    statusRuleTitie.setRuleValue("状态");
    //    MdmModuleDbFiledsRuleEntity statusRulerow = new MdmModuleDbFiledsRuleEntity();
    //    statusRulerow.setFormName("optionRuleForm");
    //    statusRulerow.setRuleCode("row");
    //    statusRulerow.setRuleName("宽度");
    //    statusRulerow.setRuleType("2");
    //    statusRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity statusRuletype = new MdmModuleDbFiledsRuleEntity();
    //    statusRuletype.setFormName("optionRuleForm");
    //    statusRuletype.setRuleCode("type");
    //    statusRuletype.setRuleName("数据类型");
    //    statusRuletype.setRuleType("2");
    //    statusRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity statusRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    statusRulerequired.setFormName("optionRuleForm");
    //    statusRulerequired.setRuleCode("required");
    //    statusRulerequired.setRuleName("必填");
    //    statusRulerequired.setRuleType("2");
    //    statusRule.add(statusRulerequired);
    //    statusRule.add(statusRuletype);
    //    statusRule.add(statusRulerow);
    //    statusRule.add(statusRuleTitie);
    //    statusFiled.setMdmModuleDbFiledsRules(statusRule);
    //    mdmModuleDbFiledsEntityList.add(statusFiled);
    //
    //
    //    //msg
    //    MdmModuleDbFiledsEntity msgFiled = new MdmModuleDbFiledsEntity();
    //    msgFiled.setChName("描述");
    //    msgFiled.setEnName("msg");
    //    msgFiled.setFiledLength("200");
    //    msgFiled.setFiledType("3");
    //    List<MdmModuleDbFiledsRuleEntity> msgRule = new ArrayList<>();
    //    MdmModuleDbFiledsRuleEntity msgRuleTitie = new MdmModuleDbFiledsRuleEntity();
    //    msgRuleTitie.setFormName("optionRuleForm");
    //    msgRuleTitie.setRuleCode("title");
    //    msgRuleTitie.setRuleName("显示名");
    //    msgRuleTitie.setRuleType("2");
    //    msgRuleTitie.setRuleValue("描述");
    //    MdmModuleDbFiledsRuleEntity msgRulerow = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerow.setFormName("optionRuleForm");
    //    msgRulerow.setRuleCode("row");
    //    msgRulerow.setRuleName("宽度");
    //    msgRulerow.setRuleType("2");
    //    msgRulerow.setRuleValue("6");
    //    MdmModuleDbFiledsRuleEntity msgRuletype = new MdmModuleDbFiledsRuleEntity();
    //    msgRuletype.setFormName("optionRuleForm");
    //    msgRuletype.setRuleCode("type");
    //    msgRuletype.setRuleName("数据类型");
    //    msgRuletype.setRuleType("2");
    //    msgRuletype.setRuleValue("input");
    //    MdmModuleDbFiledsRuleEntity msgRulerequired = new MdmModuleDbFiledsRuleEntity();
    //    msgRulerequired.setFormName("optionRuleForm");
    //    msgRulerequired.setRuleCode("required");
    //    msgRulerequired.setRuleName("必填");
    //    msgRulerequired.setRuleType("2");
    //    msgRule.add(msgRulerequired);
    //    msgRule.add(msgRuletype);
    //    msgRule.add(msgRulerow);
    //    msgRule.add(msgRuleTitie);
    //    msgFiled.setMdmModuleDbFiledsRules(msgRule);
    //    mdmModuleDbFiledsEntityList.add(msgFiled);
    //    return mdmModuleDbFiledsEntityList;
    //}
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 查询数据（list 或者 分页）
    // * @Date 1:33 下午 2023/7/12
    // **/
    //@Override
    //public JsonResultEntity queryMdmOptionData(JSONObject object) {
    //    ModuleDto entity = getData("jsonStr", object, ModuleDto.class);
    //    //校验是否有servecr传参
    //    if (!checkStr(entity.getService())) {
    //        return BaseResult.getFailureMessageEntity("请先传递服务名");
    //    }
    //    if (!checkStr(entity.getValue())) {
    //        return BaseResult.getFailureMessageEntity("请先传递存储字段");
    //    }
    //    if (!checkStr(entity.getLabel())) {
    //        return BaseResult.getFailureMessageEntity("请先传递显示字段");
    //    }
    //    //查询数据源主表
    //    MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //    mdmModuleDbEntity.setId(entity.getId());
    //    mdmModuleDbEntity.setSts("Y");
    //    List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //    if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
    //        return BaseResult.getFailureMessageEntity("系统错误");
    //    }
    //    entity.setTableName(mdmModuleDbEntityList.get(0).getDbName());
    //    if (entity.getPageNum() != null && entity.getPageSize() != null) {
    //        PageHelper.startPage(entity.getPageNum(), entity.getPageSize());
    //        List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateData(entity);
    //        PageInfo pageInfo = new PageInfo(mapList);
    //        return BaseResult.getSuccessMessageEntity("查询数据成功", pageInfo);
    //    } else {
    //        List<HashMap<String, Object>> mapList = mdmModuleDao.queryTemplateData(entity);
    //        return BaseResult.getSuccessMessageEntity("查询数据成功", mapList);
    //    }
    //}
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据 区分类型 新增、修改、查看
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity queryMdmShowDetailsData(JSONObject object) {
        MdmDto entity = getData("jsonStr", object, MdmDto.class);
        if (entity == null) {
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        if (entity.getMdmCode() == null || "".equals(entity.getMdmCode())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        if (entity.getId() == null || "".equals(entity.getId())) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询模版

        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(entity.getMdmCode());
        if (mdmModuleEntity == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        //查询数据源主表
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String tablename = null;
        JSONObject jsonObject = new JSONObject();
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            //查询数据
            Map<String, Object> queryData = new HashMap<>();
            queryData.put("tableName", mdmModuleDbEntityList.get(i).getDbName());//表名
            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                queryData.put("detailFlag", false);//是否明细
                queryData.put("id", entity.getId());//字段
                HashMap<String, Object> datas = mdmModuleDbDao.getServiceDataById(queryData);
                jsonObject.put(mdmModuleDbEntityList.get(i).getDbName(), datas);
                tablename = mdmModuleDbEntityList.get(i).getDbName() + "_distribute";
            } else {
                queryData.put("detailFlag", true);//是否明细
                queryData.put("id", entity.getId());//字段
                List<HashMap<String, Object>> datas = mdmModuleDbDao.getServiceByFormmainId(queryData);
                jsonObject.put(mdmModuleDbEntityList.get(i).getDbName(), datas);
            }
        }
        if (tablename != null && !"".equals(tablename)) {
            Map<String, Object> queryData = new HashMap<>();
            queryData.put("tableName", tablename);//表名
            queryData.put("id", entity.getId());//字段
            List<HashMap<String, Object>> datas = mdmModuleDbDao.getServiceByDistributeId(queryData);
            jsonObject.put(tablename, datas);
        }


        return BaseResult.getSuccessMessageEntity("获取数据成功", jsonObject);
    }
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据修改
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity updateMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "data")) {
            return BaseResult.getFailureMessageEntity("请先传递要修改的数据");
        }
        JSONObject saveData = jsonObject.getJSONObject("data");
        //校验唯一
        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
        mdmModuleEntity.setMdmCode(jsonObject.getLong("mdmCode"));
        mdmModuleEntity.setSts("Y");
        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleEntity = mdmModuleEntities.get(0);
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String res = checkDataOnly(jsonObject.getInteger("mdmCode"), saveData, true, mdmModuleEntity, mdmModuleDbEntityList);

        if (res == null || "".equals(res)) {
            return BaseResult.getSuccessMessageEntity("修改数据成功");
        } else {
            return BaseResult.getFailureMessageEntity(res);
        }
    }


    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据新增
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity saveMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "data")) {
            return BaseResult.getFailureMessageEntity("请先传递要修改的数据");
        }
        JSONObject saveData = jsonObject.getJSONObject("data");
        //校验唯一
        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
        mdmModuleEntity.setMdmCode(jsonObject.getLong("mdmCode"));
        mdmModuleEntity.setSts("Y");
        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
        if (mdmModuleEntities == null || mdmModuleEntities.size() != 1) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        mdmModuleEntity = mdmModuleEntities.get(0);
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.queryBase(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        String res = checkDataOnly(jsonObject.getInteger("mdmCode"), saveData, false, mdmModuleEntity, mdmModuleDbEntityList);

        if (res == null || "".equals(res)) {
            return BaseResult.getSuccessMessageEntity("保存数据成功");
        } else {
            return BaseResult.getFailureMessageEntity(res);
        }
    }
    //
    //
    /**
     * @param object
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 主数据详情数据修改
     * @Date 9:40 上午 2023/10/18
     **/
    @Override
    public JsonResultEntity deleteMdmShowDetailsData(JSONObject object) {
        JSONObject jsonObject = getstrObj("jsonStr", object);
        //校验是否有servecr传参
        if (!checkData(jsonObject, "mdmCode")) {
            return BaseResult.getFailureMessageEntity("请先传递服务名");
        }
        if (!checkData(jsonObject, "id")) {
            return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
        }
        //校验唯一
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(jsonObject.getLong("mdmCode"));
        if (mdmModuleEntity == null ) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
        mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbEntity.setSts("Y");
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
        if (mdmModuleDbEntityList == null || mdmModuleDbEntityList.size() == 0) {
            return BaseResult.getFailureMessageEntity("系统错误");
        }
        for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
            if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {

                //查询视图，如果树形，删除下级及子集
                //查询展示类型
                MdmModuleViewEntity mdmModuleViewEntity = new MdmModuleViewEntity();
                mdmModuleViewEntity.setMdmId(mdmModuleEntity.getId());
                mdmModuleViewEntity.setSts("Y");
                List<MdmModuleViewEntity> moduleViewEntityList = mdmModuleViewDao.queryBase(mdmModuleViewEntity);
                if (moduleViewEntityList == null || moduleViewEntityList.size() != 1) {
                    return BaseResult.getFailureMessageEntity("系统错误");
                }
                mdmModuleViewEntity = moduleViewEntityList.get(0);


                //删除自己
                FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                formmainDeleteDto.setId(jsonObject.getString("id"));
                formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                if (mdmModuleViewEntity != null && mdmModuleViewEntity.getViewName() != null && "1".equals(mdmModuleViewEntity.getViewName()) &&
                        mdmModuleViewEntity.getUpIdFiled() != null && !"".equals(mdmModuleViewEntity.getUpIdFiled())) {
                    formmainDeleteDto.setUpIdFiled(mdmModuleViewEntity.getUpIdFiled());

                    Map<String, Object> queryData = new HashMap<>();
                    queryData.put("tableName", mdmModuleDbEntityList.get(i).getDbName());//表名
                    queryData.put("detailFlag", false);//是否明细
                    queryData.put("id", jsonObject.getString("id"));//字段
                    HashMap<String, Object> datas = mdmModuleDbDao.getServiceDataById(queryData);
                    String upValue = null;
                    if (datas != null && datas.get(mdmModuleViewEntity.getUpIdFiled()) != null) {
                        upValue = datas.get(mdmModuleViewEntity.getUpIdFiled()).toString();
                    }
                    if (upValue != null) {
                        formmainDeleteDto.setUpIdFiledValue(upValue + "," + jsonObject.getString("id"));
                    } else {
                        formmainDeleteDto.setUpIdFiledValue(jsonObject.getString("id"));
                    }
                    mdmModuleDao.deleteChilder(formmainDeleteDto);
                }
                mdmModuleDao.deleteTemplateById(formmainDeleteDto);

            } else {
                //删除明细
                FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                formmainDeleteDto.setFormmain_id(jsonObject.getString("id"));
                formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                mdmModuleDao.deleteTemplateById(formmainDeleteDto);
            }
        }
        return BaseResult.getSuccessMessageEntity("删除数据成功");
    }
    //
    //
    ///**
    // * @param object
    // * @return com.hzya.frame.web.entity.JsonResultEntity
    // * @Author lvleigang
    // * @Description 处理分发数据
    // * @Date 9:40 上午 2023/10/18
    // **/
    //@Override
    //public JsonResultEntity doMdmDistribute(JSONObject object) {
    //    JSONObject jsonObject = getstrObj("jsonStr", object);
    //    //校验是否有servecr传参
    //    if (!checkData(jsonObject, "mdmCode")) {
    //        return BaseResult.getFailureMessageEntity("请先传递服务名");
    //    }
    //    if (!checkData(jsonObject, "id")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if (!checkData(jsonObject, "appID")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if (!checkData(jsonObject, "dataType")) {
    //        return BaseResult.getFailureMessageEntity("请先传递要删除的数据");
    //    }
    //    if("2".equals(jsonObject.getString("dataType"))){
    //        boolean flag = false;
    //        //1、根据服务名查询分发数据
    //        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //        mdmModuleEntity.setMdmCode(jsonObject.getInteger("mdmCode"));
    //        mdmModuleEntity.setSts("Y");
    //        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //        if (mdmModuleEntities != null && mdmModuleEntities.size() == 1) {
    //            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //            mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            mdmModuleDbEntity.setDbType("1");
    //            mdmModuleDbEntity.setSts("Y");
    //            List<MdmModuleDbEntity> mdmModuleDbEntities =  mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //            if (mdmModuleDbEntities != null && mdmModuleDbEntities.size() == 1) {
    //                mdmModuleDbEntity = mdmModuleDbEntities.get(0);
    //            }
    //            MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //            mdmModuleDistributeEntity.setAppId(jsonObject.getString("appID"));
    //            mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //            if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() == 1) {
    //                if (mdmModuleDistributeEntities.get(0).getAddType() != null && "1".equals(mdmModuleDistributeEntities.get(0).getAddType())) {
    //                    //2、查找插件
    //                    if (mdmModuleDistributeEntities.get(0).getAddPlug() != null && !"".equals(mdmModuleDistributeEntities.get(0).getAddPlug())) {
    //                        //2、查找插件
    //                        SysApplicationPluginEntity sysApplicationPluginEntity = sysApplicationPluginDao.get(mdmModuleDistributeEntities.get(0).getAddPlug());
    //                        if(sysApplicationPluginEntity.getPluginCode() != null && !"".equals(sysApplicationPluginEntity.getPluginCode())){
    //                            //3、调用插件
    //                            PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(sysApplicationPluginEntity.getPluginCode());
    //                            try {
    //                                JsonResultEntity s = pluginBaseEntity.executeBusiness(jsonObject);
    //                                flag = true;
    //                            } catch (Exception e) {
    //                                logger.error("插件处理失败"+e.getMessage());
    //                            }
    //                        }
    //                    }
    //                } else {
    //                    //TODO 连线
    //                    flag = true;
    //                }
    //            }
    //            if(mdmModuleDbEntity.getDbName()!= null && !"".equals(mdmModuleDbEntity.getDbName())) {
    //                MdmDistributeEntity mdmDistributeEntity = new MdmDistributeEntity();
    //                mdmDistributeEntity.setCreate();
    //                mdmDistributeEntity.setTableName(mdmModuleDbEntity.getDbName()+"_distribute");
    //                mdmDistributeEntity.setFormmainId(jsonObject.getString("id"));
    //                mdmDistributeEntity.setAppId(jsonObject.getString("appID"));
    //                mdmDistributeEntity.setStatus("1");
    //                mdmDistributeEntity.setMsg("发送成功");
    //                if (!flag) {
    //                    mdmDistributeEntity.setStatus("3");
    //                    mdmDistributeEntity.setMsg("发送失败");
    //                }
    //                mdmModuleDao.saveDistribute(mdmDistributeEntity);
    //                return BaseResult.getSuccessMessageEntity("下发数据成功");
    //
    //            }else {
    //                return BaseResult.getFailureMessageEntity("系统错误");
    //            }
    //        }else {
    //            return BaseResult.getFailureMessageEntity("系统错误");
    //        }
    //    }else {
    //        if (!checkData(jsonObject, "distributeID")) {
    //            return BaseResult.getFailureMessageEntity("请先传递分发数据");
    //        }
    //        boolean flag = false;
    //        //1、根据服务名查询分发数据
    //        MdmModuleEntity mdmModuleEntity = new MdmModuleEntity();
    //        mdmModuleEntity.setMdmCode(jsonObject.getInteger("mdmCode"));
    //        mdmModuleEntity.setSts("Y");
    //        List<MdmModuleEntity> mdmModuleEntities = mdmModuleDao.queryBase(mdmModuleEntity);
    //        if (mdmModuleEntities != null && mdmModuleEntities.size() == 1) {
    //            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
    //            mdmModuleDbEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            mdmModuleDbEntity.setDbType("1");
    //            mdmModuleDbEntity.setSts("Y");
    //            List<MdmModuleDbEntity> mdmModuleDbEntities =  mdmModuleDbDao.queryBase(mdmModuleDbEntity);
    //            if (mdmModuleDbEntities != null && mdmModuleDbEntities.size() == 1) {
    //                mdmModuleDbEntity = mdmModuleDbEntities.get(0);
    //            }
    //            MdmModuleDistributeEntity mdmModuleDistributeEntity = new MdmModuleDistributeEntity();
    //            mdmModuleDistributeEntity.setAppId(jsonObject.getString("appID"));
    //            mdmModuleDistributeEntity.setMdmId(mdmModuleEntities.get(0).getId());
    //            List<MdmModuleDistributeEntity> mdmModuleDistributeEntities = mdmModuleDistributeDao.queryBase(mdmModuleDistributeEntity);
    //            if (mdmModuleDistributeEntities != null && mdmModuleDistributeEntities.size() == 1) {
    //                if (mdmModuleDistributeEntities.get(0).getDeleteType() != null && "1".equals(mdmModuleDistributeEntities.get(0).getDeleteType())) {
    //                    //2、查找插件
    //                    if (mdmModuleDistributeEntities.get(0).getDeletePlug() != null && !"".equals(mdmModuleDistributeEntities.get(0).getDeletePlug())) {
    //                        //2、查找插件
    //                        SysApplicationPluginEntity sysApplicationPluginEntity = sysApplicationPluginDao.get(mdmModuleDistributeEntities.get(0).getDeletePlug());
    //                        if(sysApplicationPluginEntity.getPluginCode() != null && !"".equals(sysApplicationPluginEntity.getPluginCode())){
    //                            //3、调用插件
    //                            PluginBaseEntity pluginBaseEntity = PluginUtils.getPluginsById(sysApplicationPluginEntity.getPluginCode());
    //                            try {
    //                                JsonResultEntity s = pluginBaseEntity.executeBusiness(jsonObject);
    //                                flag = true;
    //                            } catch (Exception e) {
    //                                logger.error("插件处理失败"+e.getMessage());
    //                            }
    //                        }
    //                    }
    //                } else {
    //                    //TODO 连线
    //                    flag = true;
    //                }
    //            }
    //            if(mdmModuleDbEntity.getDbName()!= null && !"".equals(mdmModuleDbEntity.getDbName())) {
    //                //删除数据
    //                MdmDistributeEntity mdmDistributeEntity = new MdmDistributeEntity();
    //                mdmDistributeEntity.setId(jsonObject.getString("distributeID"));
    //                mdmDistributeEntity.setTableName(mdmModuleDbEntity.getDbName()+"_distribute");
    //                mdmDistributeEntity.setFormmainId(jsonObject.getString("id"));
    //                mdmDistributeEntity.setAppId(jsonObject.getString("appID"));
    //                mdmDistributeEntity.setStatus("1");
    //                mdmDistributeEntity.setMsg("删除成功");
    //                if (!flag) {
    //                    mdmDistributeEntity.setStatus("3");
    //                    mdmDistributeEntity.setMsg("删除失败");
    //                }
    //                mdmModuleDao.updateDistribute(mdmDistributeEntity);
    //                return BaseResult.getSuccessMessageEntity("删除数据成功");
    //
    //            }else {
    //                return BaseResult.getFailureMessageEntity("系统错误");
    //            }
    //        }else {
    //            return BaseResult.getFailureMessageEntity("系统错误");
    //        }
    //    }
    //
    //}
    //
    /**
     * @param mdmCode
     * @param saveData
     * @param mdmModuleEntity
     * @param mdmModuleDbEntityList
     * @param flag                  修改 新增
     * @return java.lang.String
     * @Author lvleigang
     * @Description 校验数据
     * @Date 11:20 上午 2023/11/6
     **/
    private String checkDataOnly(Integer mdmCode, JSONObject saveData, boolean flag, MdmModuleEntity mdmModuleEntity, List<MdmModuleDbEntity> mdmModuleDbEntityList) {
        StringBuffer str = new StringBuffer();

        //查询字段
        //查询字段下的必填规则
        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
        mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
        mdmModuleDbFiledsEntity.setSts("Y");
        mdmModuleDbFiledsEntity.setRoletype("required");
        mdmModuleDbFiledsEntity.setRoleValue("true");
        List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntityList = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity);

        if (mdmModuleDbFiledsEntityList != null && mdmModuleDbFiledsEntityList.size() > 0) {
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                    for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                        if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                            if (jsonObject.get(mdmModuleDbFiledsEntityList.get(i1).getEnName()) == null || "".equals(jsonObject.getString(mdmModuleDbFiledsEntityList.get(i1).getEnName()))) {
                                if (str.toString() != null && !"".equals(str.toString())) {
                                    str.append("；");
                                }
                                str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "不为空");
                            }
                        }
                    }
                } else {
                    JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                    if (jsonArray != null && jsonArray.size() > 0) {
                        for (int i1 = 0; i1 < mdmModuleDbFiledsEntityList.size(); i1++) {
                            if (mdmModuleDbFiledsEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                                    JSONObject jsonObject = jsonArray.getJSONObject(i2);
                                    if (jsonObject.get(mdmModuleDbFiledsEntityList.get(i1).getEnName()) == null || "".equals(jsonObject.getString(mdmModuleDbFiledsEntityList.get(i1).getEnName()))) {
                                        if (str.toString() != null && !"".equals(str.toString())) {
                                            str.append("；");
                                        }
                                        str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "不为空");
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        if (str == null || "".equals(str.toString())) {
            //校验数据
            MdmModuleDbFiledsEntity onlyFiledsEntity = new MdmModuleDbFiledsEntity();
            onlyFiledsEntity.setMdmId(mdmModuleEntity.getId());
            onlyFiledsEntity.setSts("Y");
            onlyFiledsEntity.setRoletype("fieldsSole");
            onlyFiledsEntity.setRoleValue("true");

            List<MdmModuleDbFiledsEntity> onlyEntityList = mdmModuleDbFiledsDao.queryBase(onlyFiledsEntity);

            if (onlyEntityList != null && onlyEntityList.size() > 0) {
                for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                    if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                        JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                        for (int i1 = 0; i1 < onlyEntityList.size(); i1++) {
                            if (onlyEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                //校验唯一
                                Map<String, String> map = new HashMap<>();
                                map.put("tableName", mdmModuleDbEntityList.get(i).getDbName());
                                if (flag) {
                                    map.put("id", jsonObject.getString("id"));
                                }
                                map.put("filedName", onlyEntityList.get(i1).getEnName());
                                map.put("filedValue", jsonObject.getString(onlyEntityList.get(i1).getEnName()));
                                Integer count = mdmModuleDao.checkData(map);
                                if (count > 0) {
                                    if (str.toString() != null && !"".equals(str.toString())) {
                                        str.append("；");
                                    }
                                    str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "已存在");
                                }
                            }
                        }
                    } else {
                        JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                        if (jsonArray != null && jsonArray.size() > 0) {
                            for (int i1 = 0; i1 < onlyEntityList.size(); i1++) {
                                if (onlyEntityList.get(i1).getDbId().equals(mdmModuleDbEntityList.get(i).getId())) {
                                    for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                                        JSONObject jsonObject = jsonArray.getJSONObject(i2);

                                        //校验唯一
                                        Map<String, String> map = new HashMap<>();
                                        map.put("tableName", mdmModuleDbEntityList.get(i).getDbName());
                                        if (flag) {
                                            map.put("id", jsonObject.getString("id"));
                                        }
                                        map.put("filedName", onlyEntityList.get(i1).getEnName());
                                        map.put("filedValue", jsonObject.getString(onlyEntityList.get(i1).getEnName()));
                                        Integer count = mdmModuleDao.checkData(map);
                                        if (count > 0) {
                                            if (str.toString() != null && !"".equals(str.toString())) {
                                                str.append("；");
                                            }
                                            str.append(mdmModuleDbEntityList.get(i).getRemark() + "的" + mdmModuleDbFiledsEntityList.get(i1).getChName() + "已存在");
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }


        //保存数据
        if (str == null || "".equals(str.toString())) {
            String id = UUIDUtils.getUUID();
            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("1".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    JSONObject jsonObject = saveData.getJSONObject(mdmModuleDbEntityList.get(i).getDbName());
                    //保存数据
                    MdmDataDto mdmDataDto = new MdmDataDto();
                    mdmDataDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                    MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity1 = new MdmModuleDbFiledsEntity();
                    mdmModuleDbFiledsEntity1.setMdmId(mdmModuleEntity.getId());
                    mdmModuleDbFiledsEntity1.setDbId(mdmModuleDbEntityList.get(i).getId());
                    mdmModuleDbFiledsEntity1.setSts("Y");
                    List<MdmModuleDbFiledsEntity> fileds = mdmModuleDbFiledsDao.queryBase(mdmModuleDbFiledsEntity1);
                    //查询单据规则
                    MdmTableCodeRuleEntity mdmTableCodeRuleEntity = new MdmTableCodeRuleEntity();
                    mdmTableCodeRuleEntity.setMdmId(mdmModuleEntity.getId());
                    mdmTableCodeRuleEntity.setDbId(mdmModuleDbEntityList.get(i).getId());
                    mdmTableCodeRuleEntity.setSts("Y");
                    List<MdmTableCodeRuleEntity> allMdmTableCodeRuleEntities = mdmTableCodeRuleDao.queryBase(mdmTableCodeRuleEntity);
                    List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntities = new ArrayList<>();
                    if(allMdmTableCodeRuleEntities != null && allMdmTableCodeRuleEntities.size() > 0){
                        for (int i1 = 0; i1 < allMdmTableCodeRuleEntities.size(); i1++) {
                            if(mdmModuleDbEntityList.get(i).getId().equals(allMdmTableCodeRuleEntities.get(i1).getDbId())){
                                mdmTableCodeRuleEntities.add(allMdmTableCodeRuleEntities.get(i1));
                            }
                        }
                    }
                    StringBuffer document_rule = new StringBuffer();
                    Integer document_rule_num = 0;
                    if (mdmTableCodeRuleEntities != null && mdmTableCodeRuleEntities.size() > 0) {
                        for (int i1 = 0; i1 < mdmTableCodeRuleEntities.size(); i1++) {
                            //1、连接符号 2、字符串 3、日期 4、流水号
                            if ("1".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule.append("-");
                            } else if ("2".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule.append(mdmTableCodeRuleEntities.get(i1).getDbValue());
                            } else if ("3".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                SimpleDateFormat sdf = new SimpleDateFormat(mdmTableCodeRuleEntities.get(i1).getDbValue());//要转换的时间格式
                                String stra = sdf.format(new Date());
                                document_rule.append(stra);
                            } else if ("4".equals(mdmTableCodeRuleEntities.get(i1).getDbType())) {
                                document_rule_num = mdmTableCodeRuleEntities.get(i1).getDbValue().length();
                            }
                        }
                    }
                    List<MdmDataFiledDto> mdmDataFiledDtos = new ArrayList<>();
                    for (int i1 = 0; i1 < fileds.size(); i1++) {
                        if (jsonObject.get(fileds.get(i1).getEnName()) != null) {
                            MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                            mdmDataFiledDto.setFiledsName(fileds.get(i1).getEnName());
                            mdmDataFiledDto.setFiledsValue(jsonObject.getString(fileds.get(i1).getEnName()));
                            mdmDataFiledDtos.add(mdmDataFiledDto);
                        }
                    }
                    MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                    mdmDataFiledDto.setFiledsName("logid");
                    mdmDataFiledDto.setFiledsValue(StpUtil.getLoginIdAsString());
                    mdmDataFiledDtos.add(mdmDataFiledDto);
                    mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                    if (flag) {
                        mdmDataDto.setId(jsonObject.getString("id"));
                        id = jsonObject.getString("id");
                        int a = mdmModuleDao.updateForm(mdmDataDto);
                    } else {

                        mdmDataDto.setDbType(mdmModuleDbEntityList.get(i).getDbType());
                        mdmDataDto.setDocumentRule(document_rule.toString());
                        mdmDataDto.setDocumentRuleNum(document_rule_num);
                        MdmDataFiledDto ids = new MdmDataFiledDto();
                        ids.setFiledsName("id");
                        ids.setFiledsValue(id);
                        mdmDataFiledDtos.add(ids);
                        mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                        int a = mdmModuleDao.saveForm(mdmDataDto);
                    }
                }
            }

            for (int i = 0; i < mdmModuleDbEntityList.size(); i++) {
                if ("2".equals(mdmModuleDbEntityList.get(i).getDbType())) {
                    //删除明细
                    FormmainDeleteDto formmainDeleteDto = new FormmainDeleteDto();
                    formmainDeleteDto.setFormmain_id(id);
                    formmainDeleteDto.setLoginId(StpUtil.getLoginIdAsString());
                    formmainDeleteDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                    mdmModuleDao.deleteTemplateById(formmainDeleteDto);

                    JSONArray jsonArray = saveData.getJSONArray(mdmModuleDbEntityList.get(i).getDbName());
                    if (jsonArray != null && jsonArray.size() > 0) {
                        MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity1 = new MdmModuleDbFiledsEntity();
                        mdmModuleDbFiledsEntity1.setMdmId(mdmModuleEntity.getId());
                        mdmModuleDbFiledsEntity1.setSts("Y");
                        List<MdmModuleDbFiledsEntity> allfileds = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity1);
                        List<MdmModuleDbFiledsEntity> fileds = new ArrayList<>();
                        if(allfileds != null && allfileds.size() > 0){
                            for (int i1 = 0; i1 < allfileds.size(); i1++) {
                                if(mdmModuleDbEntityList.get(i).getId().equals(allfileds.get(i1).getDbId())){
                                    fileds.add(allfileds.get(i1));
                                }
                            }
                        }

                        for (int i2 = 0; i2 < jsonArray.size(); i2++) {
                            JSONObject jsonObject = jsonArray.getJSONObject(i2);
                            //保存数据
                            MdmDataDto mdmDataDto = new MdmDataDto();
                            mdmDataDto.setTableName(mdmModuleDbEntityList.get(i).getDbName());
                            List<MdmDataFiledDto> mdmDataFiledDtos = new ArrayList<>();
                            for (int i1 = 0; i1 < fileds.size(); i1++) {
                                MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                                mdmDataFiledDto.setFiledsName(fileds.get(i1).getEnName());
                                mdmDataFiledDto.setFiledsValue(jsonObject.getString(fileds.get(i1).getEnName()));
                                mdmDataFiledDtos.add(mdmDataFiledDto);
                            }
                            MdmDataFiledDto mdmDataFiledDto = new MdmDataFiledDto();
                            mdmDataFiledDto.setFiledsName("logid");
                            mdmDataFiledDto.setFiledsValue(StpUtil.getLoginIdAsString());
                            mdmDataFiledDtos.add(mdmDataFiledDto);

                            MdmDataFiledDto formain_id = new MdmDataFiledDto();
                            formain_id.setFiledsName("formmain_id");
                            formain_id.setFiledsValue(id);
                            mdmDataFiledDtos.add(formain_id);

                            mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                            if (jsonObject.getString("id") != null) {
                                MdmDataFiledDto sts = new MdmDataFiledDto();
                                sts.setFiledsName("sts");
                                sts.setFiledsValue("Y");
                                mdmDataFiledDtos.add(sts);
                                mdmDataDto.setId(jsonObject.getString("id"));
                                int a = mdmModuleDao.updateForm(mdmDataDto);
                            } else {
                                MdmDataFiledDto ids = new MdmDataFiledDto();
                                ids.setFiledsName("id");
                                ids.setFiledsValue(UUIDUtils.getUUID());
                                mdmDataFiledDtos.add(ids);
                                mdmDataDto.setMdmDataFiledDtos(mdmDataFiledDtos);
                                mdmDataDto.setDbType(mdmModuleDbEntityList.get(i).getDbType());
                                int a = mdmModuleDao.saveForm(mdmDataDto);
                            }
                        }
                    }
                }
            }
        }
        return str.toString();
    }


    /**
     * @param jsonObject
     * @return boolean
     * @Author lvleigang
     * @Description 校验是否有值
     * @Date 2:20 下午 2023/7/10
     **/
    private boolean checkData(JSONObject jsonObject, String key) {
        if (jsonObject != null
                && jsonObject.getString(key) != null
                && !"".equals(jsonObject.getString(key))) {
            return true;
        }
        return false;
    }

    protected <T> T getData(String key, JSONObject jsonObject, Class<T> clz) {
        if (checkStr(jsonObject.getString(key))) {
            return jsonObject.getJSONObject(key).toJavaObject(clz);
        }
        return null;
    }

    /**
     * @param key
     * @param object
     * @return com.alibaba.fastjson.JSONObject
     * @Author lvleigang
     * @Description 获取对象转换成jsonobj
     * @Date 11:51 下午 2023/7/10
     **/
    protected JSONObject getstrObj(String key, JSONObject object) {
        if (checkStr(object.getString(key))) {
            return object.getJSONObject(key);
        }
        return new JSONObject();
    }

    /**
     * @param str
     * @return void
     * @Author lvleigang
     * @Description 校验字符串
     * @Date 11:41 上午 2022/12/7
     **/
    protected Boolean checkStr(String str) {
        Boolean flag = true;
        if (str == null || "".equals(str)) {
            flag = false;
        }
        return flag;
    }

}
